function new_sbd_ctx = submod_restrict_group(supp, sbd_ctx, par)

% Restrict the graph in sbd_ctx by only keeping the nodes in supp
% Input:
%   supp: the support (set of nodes) picked
%   sbd_ctx: the submodular context which contains the G_by_V graph
%   par: the parameters of the experiment
%
% Output:
%   new_sbd_ctx: the result context after restricting the graph

  G_by_V = sbd_ctx.G_by_V(:, supp);
  new_sbd_ctx.G_by_V = G_by_V(sum(G_by_V, 2) > 0, :);
  new_sbd_ctx.V_by_G = new_sbd_ctx.G_by_V';
  
end
