% Smoothed version of ||W - A||_1,1
function [f, G, H] = smooth_L11(W, A, sigma)
          
  Y = W - A;
  idx = find (abs(Y) < sigma);
  f = 0; G = 0; H = 0;
  
  if nargout < 3
    Z = abs(Y) - sigma/2;
    Z(idx) = Y(idx).^2 * (0.5/sigma);

    f = sum(sum(Z)); 
    if nargout == 2
      G = sign(Y);
      G(idx) = Y(idx)/sigma;
    end
  end
  
  if nargout == 3
    H = zeros(size(Y));
    H(idx) = 1/sigma;
  end
    
%   denom = size(W,2);
%   f = f / denom;
%   G = G / denom;

end
