function script_mat_complete(par)
  
  warning off;
  
  ori_par = par;
  gvalue = get_global_value();
  load([gvalue.data_root '/' par.dataset '/' par.dataset '.mat']);  
  d1 = context.data_ls.d1;  d2 = context.data_ls.d2;
  
  obj_func = @(varargin) matrix_completion(context.data_ls, varargin{:});
  eval_func = @(X) matrix_completion(context.data_ts, X, 'eval');
  update_ctx = mc_context(context.data_ls);
  
  X0 = sparse(d1, d2);  
  lambda = str2double(par.lambda_str);
  par.ori_par = ori_par;
  par.res_fname = [gvalue.root '/result/mat_complete/mc_' ...
                  par.dataset '_lam=' par.lambda_str ...
                  '_' par.algo '.mat'];

  switch par.algo
    case 'LOB'
      par = get_options(par, init_opts_LOB());
      [X_LOB, obj_LOB, res] = solve_LOB(obj_func, lambda, X0, eval_func, par);

      res.B = (res.obj_list(end) - res.loss_list(end)) / lambda;
      
    case 'DRTR'
      par = get_options(par, init_opts_DRTR([d1, d2]));
      par.data_ls = context.data_ls;
      par.data_ts = context.data_ts;
      [X_DRTR, obj_DRTR, res] = solve_DRTR(obj_func, lambda, X0, eval_func, par);
                                          
    case 'r1d'
      par = get_options(par, init_opts_r1d());
      [X_r1d, obj_r1d, res] = solve_r1d(obj_func, lambda, X0, eval_func, ...
                                            update_ctx, par);

    case 'SDP'
      default = struct('rtol', 1e-4, ...
                       'max_iter', 500, ...
                       'max_time', 1000, ...
                       'lstype', -1 ...
                       );

      par = get_options(par, default);
      [X_SDP, obj_SDP, res] = solve_SDP(obj_func, 2*par.B, X0, eval_func, par);
  end
end
